/**
Horloge GPS
Version A du firmware -> pour afficheur LCD 2x16c
**/

#define F_CPU 16000000

#include <util/delay.h>
#include <avr/io.h>
#include <stdint.h> 
#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>


#include "dm_lcd3.cpp" // l'attribution des pins/ports pour le LCD (et le type de LCD) est faite dans le fichier dm_lcd.h
#include "LCD_gros_chiffres2_628.c"
#include "uart_628.c"


  char version[] = "version 2.4";

  uint8_t heure, minute, seconde;
  uint8_t heure_ok, minute_ok, seconde_ok;
  uint8_t jour, mois;
  uint16_t annee;
  uint8_t jour_de_la_semaine;
  uint8_t octet_recu;
	uint8_t buffer232[100];
  uint16_t compteur1;
  uint8_t a_effacer;


  

void init_ports (void)  // ports perso
// 0 = entree, 1=sortie   ;   les 1 sur les pins en entrees activent les R de Pull Up (tirage à VCC)
{
  DDRB |= 0b11111111;
  PORTB = 0b00000000;
  
  DDRC = 	0b11111111;	// bit4=SDA ; bit5=SLC 
  PORTC = 0b00000000;

  DDRD =  0b11101110; // PD0 = entree RXD;  PD4 = switch
  PORTD = 0b00010000;
}


void InitINTs (void)
{

}


void init_variables(void)
{
  compteur1 = 0;
  heure = 0;
  minute=0;
  seconde=0;
  jour =1;
  mois=1;
  annee=0;
  a_effacer =1;
}



void init_lcd()
{
	uint8_t i;
	
	lcd_init(LCD_DISP_ON_CURSOR); // cursor on
//cd_init(LCD_DISP_ON);  // cursor off
	
	lcd_clrscr();
}



void lcd_gotoxy_clrEOL (int x, int y)
// place le curseur en x,y et efface jusqu'à la fin de la ligne
{
	lcd_gotoxy(x, y);
	uint8_t i;
	for (i=x; i<20; i++){ lcd_puts(" "); }
	lcd_gotoxy(x, y);
}






void lcd_aff_nb (uint32_t valeur, uint8_t nb_chiffres, uint8_t nb_decimales, uint8_t affi_zeros)
{
//affiche un nombre en representation decimale
// affi_zeros = 1 affiche les zéros non significatifs à gauche.
	unsigned char r ;
	char tbl[7];
	char digit;
	uint8_t i;

	for (i=1; i<=nb_chiffres; i++) 
	{
		r=48 + valeur % 10; // modulo (reste de la division)
		valeur /= 10; // quotient
		tbl[i]=r;
	}
	uint8_t debut = 1-affi_zeros; // pour ne pas afficher des zeros à gauche du 1er chiffre
	for (i=1; i<=nb_chiffres; i++)
	{
		if (i== (nb_chiffres - nb_decimales +1) )  { lcd_puts("."); }
		digit = tbl[nb_chiffres +1 -i];
		if (digit != '0') {debut = 0;}
		if ((digit != '0') || (debut == 0)) {lcd_putc(digit);}
	}
}


void lcd_aff_nb_relatif (int16_t valeur, uint8_t nb_chiffres, uint8_t nb_decimales)
{
//affiche un nombre relatif (c.a.d positif ou négatif) en representation decimale
	unsigned char r ;
	char tbl[7];
	char digit;
	uint8_t i;
	uint8_t affi_zeros = 1; // affi_zeros = 1 affiche les zéros non significatifs à gauche.

	if (valeur <0)
	{
		valeur = -valeur;
		lcd_putc('-');
	}
	else
	{
		lcd_putc('+');
	}
	
	for (i=1; i<=nb_chiffres; i++) 
	{
		r=48 + valeur % 10; // modulo (reste de la division)
		valeur /= 10; // quotient
		tbl[i]=r;
	}
	uint8_t debut = 1-affi_zeros; // pour ne pas afficher des zeros à gauche du 1er chiffre
	for (i=1; i<=nb_chiffres; i++)
	{
		if (i== (nb_chiffres - nb_decimales +1) )  { lcd_puts("."); }
		digit = tbl[nb_chiffres +1 -i];
		if (digit != '0') {debut = 0;}
		if ((digit != '0') || (debut == 0)) {lcd_putc(digit);}
	}
}



void lcd_aff_nb_form3 (uint32_t valeur, uint8_t nb_chiffres)
{
//affiche un nombre en representation decimale en separant les groupes de 3 chiffres
	unsigned char r ;
	char tbl[7];
	uint8_t i;

	for (i=1; i<=nb_chiffres; i++) 
	{
		r=48 + valeur % 10; // modulo (reste de la division)
		valeur /= 10; // quotient
		tbl[i]=r;
	}
	for (i=1; i<= nb_chiffres; i++)
	{
		if ((((i-1) % 3) == 0 ) && (i>1))  { lcd_puts("."); }
		lcd_putc(tbl[nb_chiffres +1 -i]);
	}
}



void lcd_aff_bin (uint16_t valeur, uint8_t nb_digits)
{
//affiche un nombre en representation binaire
// 16 bits max
	uint8_t r ;
	char tbl[17];
	uint8_t i;

	for (i=1; i<=nb_digits; i++) 
	{
		r= 48 + valeur % 2; // modulo (reste de la division)
		valeur /= 2; // quotient
		tbl[i]=r;
	};

	for (i=1; i<=nb_digits; i++)
	{
		lcd_putc(tbl[nb_digits +1 -i]);
	}
}


void lcd_aff_hexa(uint16_t valeur, int nb_signes)
{
//affiche un nombre en representation hexadécimale
// 16 nb_signes hexa max
	unsigned char r ;
	char tbl[17];
	char signes[17] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
	uint8_t i;

	for (i=1; i<=nb_signes; i++) 
	{
		r= valeur % 16; // modulo (reste de la division)
		valeur /= 16; // quotient
		tbl[i]=signes[r];
	};

	for (i=1; i<=nb_signes; i++)
	{
		lcd_putc(tbl[nb_signes +1 -i]);
	}
	//lcd_putc('h');
}



// lcd_aff_nb (valeur,  nb_chiffres, nb_decimales, affi_zeros)
void affiche_heure()
{
  lcd_gotoxy_clrEOL (0, 0);
  lcd_aff_nb(heure, 2, 0, 1);
  lcd_gotoxy(2, 0);
  lcd_putc(':');
  lcd_gotoxy(3, 0);
  lcd_aff_nb(minute, 2, 0, 1);
  lcd_gotoxy(5, 0);
  lcd_putc(':');
  lcd_gotoxy(6, 0);
  lcd_aff_nb(seconde, 2, 0, 1);
}


void affiche_heure_BIG()
{
  uint8_t h_u, h_d, mn_u, mn_d;

 
  if(a_effacer == 1) {lcd_clrscr(); a_effacer = 0;}

  mn_d = minute / 10;
  mn_u = minute % 10;

  h_d = heure / 10;
  h_u = heure % 10;
      
  if(h_d >0) { lcd_affi_Gros_Chiffre(h_d, 0);}  else { lcd_efface_Gros_Chiffre(0); }
  lcd_affi_Gros_Chiffre(h_u, 4);
  
  if((seconde % 2) == 0) {seperateur(7);} else {lcd_efface_Gros_Chiffre(7);}
  
  lcd_affi_Gros_Chiffre(mn_d, 9);
  lcd_affi_Gros_Chiffre(mn_u, 13);
}


void affiche_date()
{
  lcd_gotoxy_clrEOL (0, 1);
  lcd_aff_nb(jour, 2, 0, 1);
  lcd_gotoxy(2, 1);
  lcd_putc('-');
  lcd_gotoxy(3, 1);
  lcd_aff_nb(mois, 2, 0, 1);
  lcd_gotoxy(5, 1);
  lcd_putc('-');
  lcd_gotoxy(6, 1);
  lcd_aff_nb(annee, 4, 0, 1);

  lcd_gotoxy(11, 1);
  
  //lcd_aff_nb(jour_de_la_semaine, 2, 0, 1);
  char jours[7][3] = { {'D', 'I', 'M'},{'L', 'U', 'N'},{'M', 'A', 'R'},{'M', 'E', 'R'},{'J', 'E', 'U'},{'V', 'E', 'N'},{'S', 'A', 'M'}};
  
  uint8_t i;
  for (i=0; i<3; i++) {lcd_putc(jours[jour_de_la_semaine][i]);}
  
}




void RAZ_buffer()
{
  uint8_t i;
  for (i=0; i<40; i++)
  {
    buffer232[i]=' ';
  }
}


void affiche_buffer232()
{
  uint8_t n;

  //lcd_gotoxy_clrEOL(0,1);
  for(n=0; n<16; n++)
  {
    lcd_gotoxy(n, 0);
    lcd_putc(buffer232[n]);
  }
 
  for(n=0; n<16; n++)
  {
    lcd_gotoxy(n, 1);
    lcd_putc(buffer232[n+16]); // +16 ou +24 ou +32 suivant ce qu'on veut explorer
  }
 
}



void affiche_buffer232_hex()
{
  uint8_t n, i;

  lcd_gotoxy_clrEOL(0,0);
  for(n=0; n<8; n++)
  {
    // affiche les 8 premiers octets sur la première ligne
    lcd_gotoxy(2*n, 0);
    lcd_aff_hexa(buffer232[n+8], 2);
  }

  lcd_gotoxy_clrEOL(0,1);
  for(n=0; n<10; n++)
  {
    // affiche les 8 octets suivants sur la seconde ligne
    lcd_gotoxy(2*n, 1);
    lcd_aff_hexa(buffer232[n+16], 2);
  }

}


void decode_message_horaire()
{
  heure_ok =0;
  minute_ok=0;
  seconde_ok=0;
  heure  = buffer232[7]  -48 + 10*(buffer232[6]  -48) +1; // +1 heure d'hiver, +2 heure d'été
  if (heure <24) {heure_ok = 1;}
  minute = buffer232[9]  -48 + 10*(buffer232[8]  -48);
  if (heure <60) {minute_ok = 1;}
  seconde= buffer232[11] -48 + 10*(buffer232[10] -48);
  if (seconde <60) {seconde_ok = 1;}

// heure =seconde; // <- pratique pour tester affichage gros chiffres
  
  jour  = buffer232[17]  -48 + 10*(buffer232[16]  -48);
  mois  = buffer232[20]  -48 + 10*(buffer232[19]  -48);
  annee  = buffer232[25]  -48 + 10*(buffer232[24]  -48) + 100*(buffer232[23]  -48) + 1000*(buffer232[22]  -48);
  
}



void calcul_jour_de_la_semaine()
{
// d'après l'Algorithme de Mike Keith
  uint16_t d, m, y, z, jds;
  
  d=jour;
  m=mois;
  y=annee;

  if (m>=3)
  {
    jds = ( ((23*m)/9) + d + 4 + y + (y/4) - (y/100) + (y/400) - 2 ) % 7;
  }
  else
  {
    z = y-1;
    jds = ( ((23*m)/9) + d + 4 + y + (z/4) - (z/100) + (z/400) ) % 7;
  }
  jour_de_la_semaine = jds;

}

/**
 Le message à transmettre au module NEO-6M peut-être affiché par u-center
 -ouvrir le fenêtre Messages (par F9 ou menu View /  Messages View)
 -choisir dans la liste la fonction à programmer (ici: UBX / CFG(config/MSG(Messages)
 -puis dans la liste déroulante qui apparait alors dans la partie droite de la fenêtre 'Messages, selectionner 'F0-08 NMEA GxZDA'
 -le message à transmettre s'affiche alors dans le cadre au dessous.

 pour UBX-CFG(config)-MSG(Messages) = F0-08 NMEA GxZDA et UART1=on
 envoyé par u-centre -> B5 62 06 01 08 00 F0 08 00 01 00 00 00 00 08 60
 
 B5 62 c'est l'entete toujours la même
 06 01 -> CFG-MSG
 08 00 -> LENGTH (=8 bytes)
 F0 08 c'est la commande ZDA (F0 = class, 08 = ID)
 00 01 00 00 code pour UART1=on
 00 00 08 60 à la fin nous donne le checksum qui convient

 Nous allons tranmettre ces 16 octets au module NEO-6M avec l'USART de l'ATmega, ce qui nous permettra pas la suite de nous passer du programme u-center
**/
void config_NEO_6M_GPS()
{
  //configure le recepteur GPS NEO-6M afin qu'il emette les informations horaires ("ZDA") sur son port RS232 
  // ce qui n'est pas le cas par défaut
  uint8_t i;
  
  uint8_t paquet[]={0xB5,0x62,0x06,0x01,0x08,0x00,0xF0,0x08,0x00,0x01,0x00,0x00,0x00,0x00,0x08,0x60 };

  for (i=0; i<16; i++)
  {
    USART_TxByte(paquet[i]);
  }
}




int main()
{
  uint8_t i, n;
  uint8_t caract_i;

	init_variables();

	init_ports();
	InitINTs();
 	init_lcd();
  cree_carateres();
  
	USART_Init();

	lcd_clrscr();
	lcd_puts("Horloge GPS");
	lcd_gotoxy(0,1);
	lcd_puts(version);
	_delay_ms(1000);


  lcd_command(LCD_DISP_ON);  // cursor off

	lcd_clrscr();


   affiche_heure();

 // sei();	// enable interruptions 

  _delay_ms(1000);
  lcd_clrscr();

  lcd_gotoxy(0,1);
  lcd_puts("config ZDA GPS");

  config_NEO_6M_GPS();
  
  _delay_ms(1000);
  
  lcd_clrscr();

  lcd_gotoxy(0,1);
  lcd_puts("Att signal GPS"); 
    
	while(1)
	{
    i=0;
		octet_recu=0;
    RAZ_buffer();


/**
caract_i = 0xB5;  while (octet_recu != caract_i)  { octet_recu=USART_RxByte(); }
buffer232[0] = caract_i;

n=1;
octet_recu ='-';
while ((octet_recu != 0x0A) && (n<26))
{
  octet_recu=USART_RxByte();
  buffer232[n]=octet_recu;
  n++;;
}
**/
    //char debut_message[5]= {'G','P','G','L','L'};
    char debut_message[5]= {'G','P','Z','D','A'};

    caract_i = debut_message[0];  while (octet_recu != caract_i)  { octet_recu=USART_RxByte(); } buffer232[i]=caract_i; i+=1;
   
    caract_i = caract_i = debut_message[1]; octet_recu=USART_RxByte();   if( octet_recu == caract_i)
    {
      buffer232[i]=caract_i; i+=1; caract_i = debut_message[2]; octet_recu=USART_RxByte();
      if( octet_recu == caract_i)
      {
        buffer232[i]=caract_i; i+=1; caract_i = debut_message[3]; octet_recu=USART_RxByte();
        if( octet_recu == caract_i)
        {
          buffer232[i]=caract_i; i+=1; caract_i = debut_message[4]; octet_recu=USART_RxByte();
          if( octet_recu == caract_i)
          {
            buffer232[i]=caract_i; i+=1;
          
            for (n=i; n<33; n++)  // 33 ou 65 suivant ce qu'on veut lire
            {
              octet_recu=USART_RxByte();
              buffer232[n]=octet_recu;
            }

            //affiche_buffer232();

            decode_message_horaire();
            if ((heure_ok==1) && (minute_ok==1) && (seconde_ok==1))
            {
              if ((PIND & 0b00010000) !=0 )
              {
                calcul_jour_de_la_semaine();
                affiche_heure();
                affiche_date();
                a_effacer = 1;
              }
              else
              {
                affiche_heure_BIG();
              }
            
            }
            
          }
        }
      }
    }

    //affiche_buffer232();
    //affiche_buffer232_hex();
    
    compteur1--;
    if (compteur1 == 0)
    {
      compteur1 = 100;
    }
    
    _delay_ms(20);
  
  }

}




