/************************************************************************************
LCD_gros_chiffres_628.c
pour LCD 2x16 à Controller/Driver (HD44780)

Ce code ci-dessous est inspiré du travail de " Written by Isaac A. on Dec. 9, 2014 "
Le principe est repris à l'identique, les chiffres ont été redessinés (plus arrondis)

Silicium628 - 30 décembre 2015
*************************************************************************************/

// commands
#define LCD_SET_CG_RAM_ADDR 0x40

    uint8_t bottom[8] =
    {
       0b00000,
       0b00000,
       0b00000,
       0b00000,
       0b00000,
       0b11111,
       0b11111,
       0b11111
    };
    
    uint8_t top[8] =
    {
       0b11111,
       0b11111,
       0b11111,
       0b00000,
       0b00000,
       0b00000,
       0b00000,
       0b00000
    };
    
    uint8_t fill[8] =
    {
       0b11111,
       0b11111,
       0b11111,
       0b11111,
       0b11111,
       0b11111,
       0b11111,
       0b11111
    };
    
    uint8_t leftcircle[8] =
    {
       0b00000,
       0b00000,
       0b00001,
       0b00011,
       0b00011,
       0b00001,
       0b00000,
       0b00000
    };
    
    uint8_t rightcircle[8] =
    {
       0b00000,
       0b00000,
       0b10000,
       0b11000,
       0b11000,
       0b10000,
       0b00000,
       0b00000
    };
    
    uint8_t topandbottom[8] =
    {
       0b11111,
       0b11111,
       0b00000,
       0b00000,
       0b00000,
       0b00000,
       0b11111,
       0b11111
    };
 


void lcd_cree_1_char(uint8_t location, uint8_t charmap[])
{
		uint8_t i;
		location &= 0x7; // il y a  8 locations 0-7
		lcd_command(LCD_SET_CG_RAM_ADDR | (location << 3));
		for (i=0; i<8; i++)		{	lcd_putc(charmap[i]);}
 } 


void cree_carateres()
{
  lcd_cree_1_char(0, bottom);
  lcd_cree_1_char(1, top);
  lcd_cree_1_char(2, fill);
  lcd_cree_1_char(3, leftcircle);
  lcd_cree_1_char(4, rightcircle);
  lcd_cree_1_char(5, topandbottom);

}



void espace(int pos)
{
  lcd_gotoxy(pos, 0);      lcd_puts(" ");
  lcd_gotoxy(pos + 1, 0);  lcd_puts(" ");
  lcd_gotoxy(pos, 1);      lcd_puts(" ");
  lcd_gotoxy(pos + 1, 1);  lcd_puts(" ");
}

void seperateur(int pos)
{
  lcd_gotoxy(pos, 0);      lcd_putc(3);
  lcd_gotoxy(pos + 1, 0);  lcd_putc(4);
  lcd_gotoxy(pos, 1);      lcd_putc(3);
  lcd_gotoxy(pos + 1, 1);  lcd_putc(4);
}

void zero(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos, 1);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)1);
  lcd_gotoxy(pos + 1, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)2);
}

void un(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)1);
  lcd_gotoxy(pos, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 1, 1);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 2, 0);
  lcd_puts(" ");
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)0);
}

void deux(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)1);
  lcd_gotoxy(pos, 1);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)5);
  lcd_gotoxy(pos + 1, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)0);
}

void trois(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)1);
  lcd_gotoxy(pos, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)5);
  lcd_gotoxy(pos + 1, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)2);
}

void quatre(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos, 1);
  lcd_puts(" ");
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 1, 1);
  lcd_puts(" ");
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)2);
}

void cinq(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)5);
  lcd_gotoxy(pos + 1, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)1);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)2);
}

void six(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos, 1);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)5);
  lcd_gotoxy(pos + 1, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)1);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)2);
}

void sept(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)1);
  lcd_gotoxy(pos, 1);
  lcd_puts(" ");
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)1);
  lcd_gotoxy(pos + 1, 1);
  lcd_puts(" ");
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)2);
}

void huit(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos, 1);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)5);
  lcd_gotoxy(pos + 1, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)2);
}

void neuf(int pos)
{
  lcd_gotoxy(pos, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 1, 0);
  lcd_putc((uint8_t)5);
  lcd_gotoxy(pos + 1, 1);
  lcd_putc((uint8_t)0);
  lcd_gotoxy(pos + 2, 0);
  lcd_putc((uint8_t)2);
  lcd_gotoxy(pos + 2, 1);
  lcd_putc((uint8_t)2);
}



void lcd_affi_Gros_Chiffre(int x, int pos)
{
  switch (x)
  {
    case 0 : zero(pos); break;
    case 1 : un(pos); break;
    case 2 : deux(pos); break;
    case 3 : trois(pos); break;
    case 4 : quatre(pos); break;
    case 5 : cinq(pos); break;
    case 6 : six(pos); break;
    case 7 : sept(pos); break;
    case 8 : huit(pos); break;
    case 9 : neuf(pos); break;
  }
}

void lcd_efface_Gros_Chiffre(int pos)
{
  lcd_gotoxy(pos, 0);      lcd_puts(" ");
  lcd_gotoxy(pos, 1);      lcd_puts(" ");
  lcd_gotoxy(pos + 1, 0);  lcd_puts(" ");
  lcd_gotoxy(pos + 1, 1);  lcd_puts(" ");
  lcd_gotoxy(pos + 2, 0);  lcd_puts(" ");
  lcd_gotoxy(pos + 2, 1);  lcd_puts(" ");
}
